dojo.provide("com.hcl.etm.adapter.server.web.ui.internal.view.extension.ServerScriptEditorSection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.xml.parser");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.RemoteExecutionScriptClient");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.RemoteExecutionScriptEditorSection");
dojo.require("com.hcl.etm.adapter.server.web.ui.internal.OTSUIUtil");

(function() { // module container

var   Constants                        = com.ibm.rqm.planning.web.client.internal.Constants;
var   OTSUIUtil						   = com.hcl.etm.adapter.server.web.ui.internal.OTSUIUtil;
var   AbstractArtifactEditorSection    = com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection;
var   TOKEN					       	   = "offlineToken"
var   BRANCH					       = "branch"
var   ASSETID					       = "assetId"
var   ENVIRONMENT					   = "environment"
var   REScriptEditorSection			   = com.ibm.rqm.execution.web.ui.internal.view.common.RemoteExecutionScriptEditorSection;

dojo.declare(
   "com.hcl.etm.adapter.server.web.ui.internal.view.extension.ServerScriptEditorSection", 
   [dijit._Widget, dijit._Templated, AbstractArtifactEditorSection, REScriptEditorSection], 
   {
   templatePath: dojo.moduleUrl("com.hcl.etm.adapter.server.web", "ui/internal/view/templates/extension/ServerScriptEditorSection.html"),
   
   offlineToken: "Offline Token",
   branch: "Branch",
   assetId: "Asset Id",
   environment: "Environment",
   sectionName: "Rational Test Automation Server",
   
   constructor: function(args) {
      this._script = args.script;
   },
   
   postCreate: function() {
   },   

   	initialize: function(){
		if (this._script != null) {
			var _script = this._script;
			this._token.value = this.getScriptProperty(_script.properties, TOKEN);
			this._branch.value = this.getScriptProperty(_script.properties, BRANCH);
			this._assetId.value = this.getScriptProperty(_script.properties, ASSETID);
			this._environment.value = this.getScriptProperty(_script.properties, ENVIRONMENT);
		}
	  	if (this.parentEditor.isReadOnly()) {
	  		this._token.readOnly = true;
			this._branch.readOnly = true;
			this._assetId.readOnly = true;
			this._environment.readOnly = true;
	  	}
	  	if(!this._tokenHandle && !this.parentEditor.isReadOnly())
	  		this._tokenHandle = this.connect(this._token, "oninput", this.setDirty);
	  	if(!this._branchHandle && !this.parentEditor.isReadOnly())
	  		this._branchHandle = this.connect(this._branch, "oninput", this.setDirty);
		if(!this._assetIdHandle && !this.parentEditor.isReadOnly())
	  		this._assetIdHandle = this.connect(this._assetId, "oninput", this.setDirty);
		if(!this._environmentHandle && !this.parentEditor.isReadOnly())
	  		this._environmentHandle = this.connect(this._environment, "oninput", this.setDirty);
		this.initialized = true;
   },
    
   getAttributes: function(){
   		var args = this.inherited("getAttributes", arguments);
		//May be Hack: If it is false or undefined, the server will look into the shared location
		args.managedByAdapter = true;
		return args;
   },
   
   getProperties: function(){
	var props = [];
	props.push({
		propertyType: "string",
		propertyName: TOKEN,
		propertyValue: this._token.value
	});
	props.push({
		propertyType: "string",
		propertyName: BRANCH,
		propertyValue: this._branch.value
	});
	props.push({
		propertyType: "string",
		propertyName: ASSETID,
		propertyValue: this._assetId.value
	});
	props.push({
		propertyType: "string",
		propertyName: ENVIRONMENT,
		propertyValue: this._environment.value
	});
	return props;
   },
   
   //@Overriden from RemoteExecutionScriptEditorSection
   getHelpContextID: function(){
      return null;
   },
   
   //@Overriden from RemoteExecutionScriptEditorSection
   getActions: function(){
      return [];
   },    
   
   validate: function(){
   	if (dojo.trim(this._token.value).length == 0) {
		 this.setValidationError(OTSUIUtil.getMessage("msgRequiredField", this.offlineToken,  this.sectionName));
		 this._token.focus();
         return false;
    }
    if (dojo.trim(this._branch.value).length == 0) {
		 this.setValidationError(OTSUIUtil.getMessage("msgRequiredField", this.branch,  this.sectionName));
		 this._branch.focus();
         return false;
    }  
    if (dojo.trim(this._assetId.value).length == 0) {
		 this.setValidationError(OTSUIUtil.getMessage("msgRequiredField", this.assetId,  this.sectionName));
		 this._assetId.focus();
         return false;
    } 
	  return true;
   },
     
   //@Overridden from RemoteExecutionScriptEditorSection
   saveFinished: function(testScript){
      this._script = testScript;
	  this.initialize();
	  this.setSectionDirty(false);
   }
   

});

})();